package phonix;

import java.util.ArrayList;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.events.FocusAdapter;
import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.ModifyEvent;

public class AddNew extends Shell {
	private static Humanoid person = new NullPerson();
	private Label lblNewLabel;
	private Label lblNewLabel_2;
	private Label lblNewLabel_3;
	private Label lblNewLabel_4;
	private Label lblNewLabel_6;
	private Text nameT;
	private Text addressT;
	private Text placeT;
	private Text zipT;
	private Text websiteT;
	private Button cancelB;
	private Button adderB;
	private static AddNew shell;
	private static DatabaseConnector connection;
	private Composite numberCo;
	private Composite emailCo;
	private Label lblNewLabel_1;
	private Combo countryBox;
	private String holder = "";
	private ArrayList<InputField> infi = new ArrayList<>();
	private ArrayList<InputField> emfi = new ArrayList<>();

	/**
	 * Launch the application.
	 * 
	 * @param args
	 */
	public static Humanoid main(DatabaseConnector con) {
		connection = con;
		try {
			Display display = Display.getDefault();
			shell = new AddNew(display);
			shell.setLocation((Display.getCurrent().getBounds().width - shell
					.getBounds().width) / 2,
					(Display.getCurrent().getBounds().height - shell
							.getBounds().height) / 2);
			shell.open();
			shell.layout();

			while (!shell.isDisposed()) {
				if (!display.readAndDispatch()) {
					display.sleep();
				}

			}

		} catch (Exception e) {
			e.printStackTrace();
		}
		return person;
	}

	/**
	 * Create the shell.
	 * 
	 * @param display
	 */
	public AddNew(Display display) {

		super(display, SWT.BORDER | SWT.TITLE | SWT.PRIMARY_MODAL);
		setLayout(new GridLayout(2, false));

		lblNewLabel = new Label(this, SWT.NONE);
		lblNewLabel.setLayoutData(new GridData(SWT.LEFT, SWT.FILL, false, true,
				1, 1));
		lblNewLabel.setText(PUtils.UTF8("LABEL_NAME"));

		nameT = new Text(this, SWT.BORDER);

		nameT.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		nameT.setSelection(nameT.getText().length());

		numberCo = new Composite(this, SWT.NONE);
		numberCo.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 2,
				1));
		numberCo.setLayout(new GridLayout(3, false));

		infi.add(new InputField(numberCo, PUtils.UTF8("LABEL_NUMBER"), this,
				infi));

		lblNewLabel_2 = new Label(this, SWT.NONE);
		lblNewLabel_2.setLayoutData(new GridData(SWT.LEFT, SWT.FILL, false,
				true, 1, 1));
		lblNewLabel_2.setText(PUtils.UTF8("LABEL_ADDRESS"));

		addressT = new Text(this, SWT.BORDER);
		addressT.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1,
				1));

		lblNewLabel_3 = new Label(this, SWT.NONE);
		lblNewLabel_3.setLayoutData(new GridData(SWT.LEFT, SWT.FILL, false,
				true, 1, 1));
		lblNewLabel_3.setText(PUtils.UTF8("LABEL_PLACE"));

		placeT = new Text(this, SWT.BORDER);
		placeT.addModifyListener(new ModifyListener() {//
			public void modifyText(ModifyEvent e) {
				holder = placeT.getText().substring(0,
						placeT.getCaretPosition());
			}
		});
		placeT.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {//
				holder = placeT.getText().substring(0,
						placeT.getCaretPosition());
			}
		});

		placeT.addKeyListener(new KeyAdapter() {
			@Override
			public void keyReleased(KeyEvent e) {
				int k = 0;
				if (Character.isLetterOrDigit(e.character)) {
					String found = setPlace(holder);
					k = holder.length();
					if (!found.equals(holder)) {
						holder = found;
						placeT.setText(holder);
						placeT.setSelection(k);
					} else {
						placeT.setText(holder);
						holder += e.character;
						placeT.setSelection(k);
					}

				}
			}
		});
		placeT.addFocusListener(new FocusAdapter() {
			@Override
			public void focusLost(FocusEvent e) {
				holder = "";
				if (!placeT.getText().equals("")) {
					findZip(placeT.getText());
					detectCountry();
				}
			}
		});

		placeT.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));

		lblNewLabel_4 = new Label(this, SWT.NONE);
		lblNewLabel_4.setLayoutData(new GridData(SWT.LEFT, SWT.FILL, false,
				true, 1, 1));
		lblNewLabel_4.setText(PUtils.UTF8("LABEL_ZIP"));

		zipT = new Text(this, SWT.BORDER);
		zipT.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		emailCo = new Composite(this, SWT.NONE);
		emailCo.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 2, 1));
		emailCo.setLayout(new GridLayout(3, false));

		emfi.add(new InputField(emailCo, "Email:", this, emfi));

		lblNewLabel_6 = new Label(this, SWT.NONE);
		lblNewLabel_6.setLayoutData(new GridData(SWT.LEFT, SWT.FILL, false,
				true, 1, 1));
		lblNewLabel_6.setText(PUtils.UTF8("LABEL_WEBSITE"));

		websiteT = new Text(this, SWT.BORDER);
		websiteT.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1,
				1));

		lblNewLabel_1 = new Label(this, SWT.NONE);
		lblNewLabel_1.setText(PUtils.UTF8("LABEL_COUNTRY"));

		countryBox = PUtils.CountryCombo(this);
		countryBox.addKeyListener(new ComboAdapter(countryBox));
		countryBox.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true,
				false, 1, 1));
		String base = connection.homeGuess();
		countryBox.select(countryBox.indexOf(PUtils.codeToCountry(base)));

		cancelB = new Button(this, SWT.NONE);
		cancelB.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				person = new NullPerson();
				shell.dispose();
			}
		});
		cancelB.setLayoutData(new GridData(SWT.LEFT, SWT.FILL, false, true, 1,
				1));
		cancelB.setImage(PUtils.getImage(this, "png/arrow-big-01.png"));
		cancelB.setToolTipText(PUtils.UTF8("BUTTON_CANCEL"));

		adderB = new Button(this, SWT.NONE);
		adderB.addMouseListener(new MouseAdapter() {
			@Override
			// Prepare the person to be returned to main window and added into
			// database
			public void mouseUp(MouseEvent e) {
				String nam = nameT.getText().trim();
				String plas = placeT.getText().trim();
				if (!nam.equals("") && !plas.equals("")) {
					String po = websiteT.getText();

					ArrayList<String> phones = new ArrayList<>();
					String tel = null;
					for (InputField field : infi) {
						if (!field.getText().trim().equals("")) {
							tel = PUtils.formatNumber(field.getText().trim());
							if (!tel.equals("") && phones.indexOf(tel) == -1)
								phones.add(tel);
						}
					}
					ArrayList<String> mails = new ArrayList<>();
					for (InputField field : emfi) {
						tel = field.getText().trim();
						if (!tel.equals("") && mails.indexOf(tel) == -1)
							mails.add(tel);
					}
					String hely = placeT.getText().trim().toLowerCase();
					hely = hely.substring(0, 1).toUpperCase()
							+ hely.substring(1);
					char c = Character.toUpperCase(nam.charAt(0));
					nam = String.valueOf(c) + nam.substring(1);
					if (po.equals(""))
						po = "-";
					String add = addressT.getText().trim();
					if (add.equals(""))
						add = "-";
					String z = zipT.getText().trim();
					if (z.equals(""))
						z = "-";
					person = new Person.Builder()
							.name(nam)
							.place(hely)
							.ZIP(z)
							.address(add)
							.website(po)
							.email(mails)
							.country(PUtils.countryToCode(countryBox.getText()))
							.number(phones).build();
					shell.dispose();
				} else {
					person = new NullPerson();
					new Thread(new Runnable() {

						@Override
						public void run() {
							getDisplay().syncExec(new Runnable() {

								@Override
								public void run() {

									try {
										Thread.sleep(500);
									} catch (InterruptedException e) {
										e.printStackTrace();
									}
									nameT.setBackground(PUtils.getColor(
											getDisplay(), 255, 0, 0));
									placeT.setBackground(PUtils.getColor(
											getDisplay(), 255, 0, 0));

								}
							});
						}

					}).start();
					new Thread(new Runnable() {

						@Override
						public void run() {
							getDisplay().syncExec(new Runnable() {

								@Override
								public void run() {

									try {
										Thread.sleep(500);
									} catch (InterruptedException e) {
										e.printStackTrace();
									}
									nameT.setBackground(PUtils.getColor(
											getDisplay(), 255, 255, 255));
									placeT.setBackground(PUtils.getColor(
											getDisplay(), 255, 255, 255));

								}
							});
						}

					}).start();

				}
			}
		});
		adderB.setLayoutData(new GridData(SWT.RIGHT, SWT.FILL, true, true, 1, 1));
		adderB.setImage(PUtils.getImage(this, "png/tick.png"));
		adderB.setToolTipText(PUtils.UTF8("BUTTON_ADD"));
		new Label(this, SWT.NONE);

		createContents();
	}

	/**
	 * Create contents of the shell.
	 */
	protected void createContents() {
		setText(PUtils.UTF8("TITLE_CONTACT"));
		setSize(298, 390);
		layout();
		pack();

	}

	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}

	private void findZip(String s) {
		String mpi = null;
		mpi = connection.ZipFinder(s);
		if (mpi != null) {
			zipT.setText(mpi);
		}
	}

	private String setPlace(String m) {
		String c = "";
		String p = null;
		if (m.length() > 1) {
			p = m.substring(0, 1).toUpperCase() + m.substring(1);
		} else {
			p = m.toUpperCase();
		}

		c = connection.cityFinder(p);
		if (c.equals(""))
			c = m;
		return c;
	}

	public void detectCountry() {
		String s = connection.countryOfTown(placeT.getText());

		if (s != null) {
			int i = countryBox.indexOf(PUtils.codeToCountry(s));
			countryBox.select(i);
		}
	}

}
