package phonix;

import java.util.ArrayList;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.FocusAdapter;
import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;

public class Editor extends Shell {
	private Label nasaas;
	private Text nameT;
	private Button deletorB;
	private Label lblNewLabel_2;
	private Text addressT;
	private Label lblNewLabel_3;
	private Combo placeT;
	private Label lblNewLabel_4;
	private Text zipT;
	private Label lblNewLabel_5;
	private Label lblNewLabel_6;
	private Text websiteT;
	private Button cancelB;
	private Button saveB;
	private static DatabaseConnector connection;
	private static Person person;
	private static Editor shell;
	private static boolean deleted = false;
	private Composite numberCo;
	private static int idx = 0;
	private Composite emailCo;
	private Button npB;
	private Composite pComposite;
	private Text plText;
	private Label lblNewLabel;
	private Combo countryBox;
	private ArrayList<InputField> infi = new ArrayList<>();
	private ArrayList<InputField> emfi = new ArrayList<>();

	/**
	 * Launch the application.
	 * 
	 * @param args
	 */
	public static boolean go(DatabaseConnector con, Humanoid p) {
		connection = con;
		person = (Person) p;
		try {
			Display display = Display.getDefault();
			shell = new Editor(display);
			shell.setLocation((Display.getCurrent().getBounds().width - shell
					.getBounds().width) / 2,
					(Display.getCurrent().getBounds().height - shell
							.getBounds().height) / 2);
			shell.fillEditor();
			shell.open();
			shell.layout();
			while (!shell.isDisposed()) {
				if (!display.readAndDispatch()) {
					display.sleep();
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return deleted;
	}

	/**
	 * Create the shell.
	 * 
	 * @param display
	 */
	public Editor(Display display) {
		super(display, SWT.SHELL_TRIM);
		setLayout(new GridLayout(3, false));

		nasaas = new Label(this, SWT.NONE);
		nasaas.setLayoutData(new GridData(SWT.LEFT, SWT.FILL, false, true, 1, 1));
		nasaas.setText(PUtils.UTF8("LABEL_NAME"));

		nameT = new Text(this, SWT.BORDER);
		nameT.addFocusListener(new FocusAdapter() {
			@Override
			public void focusLost(FocusEvent e) {
				if (!nameT.getText().equals(person.getName())) {
					checkDuplicate(nameT.getText());
				}
			}
		});
		GridData gd_nameT = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_nameT.heightHint = 25;
		nameT.setLayoutData(gd_nameT);

		deletorB = new Button(this, SWT.NONE);
		deletorB.setLayoutData(new GridData(SWT.LEFT, SWT.FILL, false, true, 1,
				1));
		deletorB.addMouseListener(new MouseAdapter() {
			@Override
			// Delete the contact
			public void mouseUp(MouseEvent e) {
				ArrayList<String> phones = new ArrayList<>();
				for (InputField field : infi) {
					phones.add(field.getText());
				}
				ArrayList<String> mails = new ArrayList<>();
				for (InputField field : emfi) {
					mails.add(field.getText());
				}
				Person p2 = new Person.Builder().name(nameT.getText())
						.number(phones).address(addressT.getText())
						.place(placeT.getText()).ZIP(zipT.getText()).ID(idx)
						.website(websiteT.getText()).email(mails).build();
				connection.delete(p2);
				deleted = true;
				shell.dispose();
			}
		});
		deletorB.setImage(PUtils.getImage(this, "png/minus-sign.png"));
		deletorB.setToolTipText(PUtils.UTF8("BUTTON_DELETE"));

		numberCo = new Composite(this, SWT.NONE);
		numberCo.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 3,
				1));
		numberCo.setLayout(new GridLayout(3, false));

		lblNewLabel_2 = new Label(this, SWT.NONE);
		lblNewLabel_2.setLayoutData(new GridData(SWT.LEFT, SWT.FILL, false,
				true, 1, 1));
		lblNewLabel_2.setText(PUtils.UTF8("LABEL_ADDRESS"));

		addressT = new Text(this, SWT.BORDER);
		GridData gd_addressT = new GridData(SWT.FILL, SWT.FILL, true, true, 1,
				1);
		gd_addressT.heightHint = 25;
		addressT.setLayoutData(gd_addressT);
		new Label(this, SWT.NONE);

		lblNewLabel_3 = new Label(this, SWT.NONE);
		lblNewLabel_3.setLayoutData(new GridData(SWT.LEFT, SWT.FILL, false,
				true, 1, 1));
		lblNewLabel_3.setText(PUtils.UTF8("LABEL_PLACE"));

		pComposite = new Composite(this, SWT.NONE);
		pComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true,
				1, 1));
		pComposite.setLayout(new GridLayout(1, false));

		placeT = new Combo(pComposite, SWT.READ_ONLY);
		placeT.addFocusListener(new FocusAdapter() {
			@Override
			public void focusLost(FocusEvent e) {
				if (!placeT.getText().equals("")) {
					findZip(placeT.getText());
					detectCountry();
				}
			}
		});
		placeT.addKeyListener(new ComboAdapter(placeT));
		placeT.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));

		for (String s : connection.getAllCities()) {
			placeT.add(s);
		}

		npB = new Button(this, SWT.CHECK);
		npB.addSelectionListener(new SelectionAdapter() {
			@Override
			// A switch to enabling new place
			public void widgetSelected(SelectionEvent e) {
				if (npB.getSelection()) {
					placeT.dispose();
					placeT = null;
					plText = new Text(pComposite, SWT.BORDER);
					GridData gd_pT = new GridData(SWT.FILL, SWT.FILL, true,
							true, 1, 1);
					gd_pT.heightHint = 25;
					plText.setLayoutData(gd_pT);
					plText.getParent().layout();
					zipT.setEditable(true);
					zipT.setText("");
					plText.setFocus();
				} else {
					plText.dispose();
					placeT = new Combo(pComposite, SWT.READ_ONLY);
					placeT.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true,
							true, 1, 1));
					placeT.getParent().layout();
					for (String s : connection.getAllCities()) {
						placeT.add(s);
					}
					zipT.setEditable(false);
					int i = placeT.indexOf(person.getPlace());
					placeT.select(i);
					zipT.setText(person.getZIP());
				}
			}
		});
		npB.setToolTipText(PUtils.UTF8("CHECK_NEW_PLACE"));
		npB.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1,
				1));
		lblNewLabel_4 = new Label(this, SWT.NONE);
		lblNewLabel_4.setLayoutData(new GridData(SWT.LEFT, SWT.FILL, false,
				true, 1, 1));
		lblNewLabel_4.setText(PUtils.UTF8("LABEL_ZIP"));

		zipT = new Text(this, SWT.BORDER | SWT.READ_ONLY);
		GridData gd_zipT = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_zipT.heightHint = 25;
		zipT.setLayoutData(gd_zipT);
		new Label(this, SWT.NONE);

		lblNewLabel_5 = new Label(this, SWT.NONE);
		lblNewLabel_5.setLayoutData(new GridData(SWT.LEFT, SWT.FILL, false,
				true, 1, 1));

		emailCo = new Composite(this, SWT.NONE);
		emailCo.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false,
				1, 1));
		emailCo.setLayout(new GridLayout(1, true));
		new Label(this, SWT.NONE);

		lblNewLabel_6 = new Label(this, SWT.NONE);
		lblNewLabel_6.setLayoutData(new GridData(SWT.LEFT, SWT.FILL, false,
				true, 1, 1));
		lblNewLabel_6.setText(PUtils.UTF8("LABEL_WEBSITE"));

		websiteT = new Text(this, SWT.BORDER);
		GridData gd_websiteT = new GridData(SWT.FILL, SWT.FILL, true, true, 1,
				1);
		gd_websiteT.heightHint = 25;
		websiteT.setLayoutData(gd_websiteT);
		new Label(this, SWT.NONE);

		lblNewLabel = new Label(this, SWT.NONE);
		lblNewLabel.setText("Country:");

		countryBox = PUtils.CountryCombo(this);
		countryBox.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true,
				false, 1, 1));
		new Label(this, SWT.NONE);
		countryBox.addKeyListener(new ComboAdapter(countryBox));
		int v = countryBox.indexOf(PUtils.codeToCountry(person.getCountry()));
		countryBox.select(v);

		cancelB = new Button(this, SWT.NONE);
		cancelB.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				shell.dispose();
			}
		});
		GridData gd_cancelB = new GridData(SWT.FILL, SWT.FILL, false, true, 1,
				1);
		gd_cancelB.heightHint = 25;
		cancelB.setLayoutData(gd_cancelB);
		cancelB.setImage(PUtils.getImage(this, "png/arrow-big-01.png"));
		cancelB.setToolTipText(PUtils.UTF8("BUTTON_CANCEL"));
		new Label(this, SWT.NONE);

		saveB = new Button(this, SWT.NONE);
		saveB.addMouseListener(new MouseAdapter() {
			@Override
			// Save the changes
			public void mouseUp(MouseEvent e) {
				String hely = null;
				int place_id = 0;
				if (placeT == null) {
					hely = plText.getText().trim();
				} else {
					hely = placeT.getText().trim();
				}

				String nam = nameT.getText().trim();
				if (!nam.equals("") && !hely.equals("")) {
					// Check existence of a new place
					if (placeT == null) {
						place_id = connection.findOrInsert(hely, zipT.getText());
					}

					hely = hely.substring(0, 1).toUpperCase()
							+ hely.substring(1);
					ArrayList<String> phones = new ArrayList<>();
					String tel = null;
					for (InputField field : infi) {
						if (!field.getText().trim().equals("")) {
							tel = PUtils.formatNumber(field.getText());
							if (!tel.equals("") && phones.indexOf(tel) == -1)
								phones.add(tel);
						}

					}
					ArrayList<String> mails = new ArrayList<>();
					for (InputField field : emfi) {
						if (!field.getText().trim().equals("")) {
							tel = field.getText().trim();
							if (!tel.equals("") && mails.indexOf(tel) == -1)
								mails.add(tel);
						}
					}

					char c = Character.toUpperCase(nam.charAt(0));
					nam = String.valueOf(c) + nam.substring(1);
					String po = websiteT.getText().trim();
					if (po.equals(""))
						po = "-";
					String add = addressT.getText().trim();
					if (add.equals(""))
						add = "-";
					String z = zipT.getText().trim();
					if (z.equals(""))
						z = "-";
					Person p2 = new Person.Builder()
							.name(nam)
							.place(hely)
							.place_id(place_id)
							.ZIP(z)
							.address(add)
							.website(po)
							.country(PUtils.countryToCode(countryBox.getText()))
							.email(mails).ID(idx).number(phones).build();
					connection.update(person, p2);
					deleted = true;
					shell.dispose();
				} else {
					new Thread(new Runnable() {

						@Override
						public void run() {
							getDisplay().syncExec(new Runnable() {

								@Override
								public void run() {

									try {
										Thread.sleep(500);
									} catch (InterruptedException e) {
										e.printStackTrace();
									}
									nameT.setBackground(PUtils.getColor(
											getDisplay(), 255, 0, 0));
									placeT.setBackground(PUtils.getColor(
											getDisplay(), 255, 0, 0));

								}
							});
						}

					}).start();
					new Thread(new Runnable() {

						@Override
						public void run() {
							getDisplay().syncExec(new Runnable() {

								@Override
								public void run() {

									try {
										Thread.sleep(500);
									} catch (InterruptedException e) {
										e.printStackTrace();
									}
									nameT.setBackground(PUtils.getColor(
											getDisplay(), 255, 255, 255));
									placeT.setBackground(PUtils.getColor(
											getDisplay(), 255, 255, 255));

								}
							});
						}

					}).start();

				}
			}
		});
		saveB.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, true, 1, 1));
		saveB.setImage(PUtils.getImage(this, "png/tick.png"));
		saveB.setToolTipText(PUtils.UTF8("BUTTON_SAVE"));
		new Label(this, SWT.NONE);
		createContents();
	}

	/**
	 * Create contents of the shell.
	 */
	protected void createContents() {
		setText(PUtils.UTF8("TITLE_EDIT"));
		setSize(574, 324);

	}

	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}

	private void fillEditor() {
		ArrayList<String> empi = new ArrayList<>();
		empi.add("");
		nameT.setText(person.getName());
		InputField o = null;
		if (person.getNumber().size() > 0) {
			for (String m : person.getNumber()) {
				o = new InputField(numberCo, PUtils.UTF8("LABEL_NUMBER"), this,
						infi);
				o.setTex(m);
			}

		} else {
			new InputField(numberCo, PUtils.UTF8("LABEL_NUMBER"), this, infi);
		}
		idx = person.getID();
		addressT.setText(person.getAddress());
		int i = placeT.indexOf(person.getPlace());
		placeT.select(i);
		zipT.setText(person.getZIP());
		InputField z = null;
		if (person.getEmail().size() > 0) {
			for (String m : person.getEmail()) {
				z = new InputField(emailCo, PUtils.UTF8("LABEL_EMAIL"), this,
						emfi);
				z.setTex(m);
			}
		} else {
			new InputField(emailCo, PUtils.UTF8("LABEL_EMAIL"), this, emfi);
		}

		websiteT.setText(person.getWebsite());
		shell.layout();
		shell.pack();
	}

	private void checkDuplicate(String s) {
		if (nameT.getText().equals("")) {
			nameT.setBackground(PUtils.getColor(getDisplay(), 255, 0, 0));
			saveB.setEnabled(false);
		} else {
			nameT.setBackground(PUtils.getColor(getDisplay(), 255, 255, 255));
			saveB.setEnabled(true);
		}
	}

	private void findZip(String s) {
		String mpi = null;
		mpi = connection.ZipFinder(s);
		if (mpi != null) {
			zipT.setText(mpi);
		}
	}

	public void detectCountry() {
		String s = connection.countryOfTown(placeT.getText());
		if (s != null) {
			int i = countryBox.indexOf(PUtils.codeToCountry(s));
			countryBox.select(i);
		}
	}

}
