package phonix;

import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.program.Program;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.wb.swt.SWTResourceManager;

public class Info extends Dialog {

	protected Object result;
	protected Shell shlAbout;
	private Label lblNewLabel;
	private StyledText styledText;
	private Label lblNewLabel_1;
	private Button btnNewButton;
	private Composite composite;
	private Label lblNewLabel_2;
	private Label lblNewLabel_3;

	/**
	 * Create the dialog.
	 * 
	 * @param parent
	 * @param style
	 */
	public Info(Shell parent, int style) {
		super(parent, style);
		setText("SWT Dialog");
	}

	/**
	 * Open the dialog.
	 * 
	 * @return the result
	 */
	public Object open() {
		createContents();
		shlAbout.setLocation(
				(Display.getCurrent().getBounds().width - shlAbout.getBounds().width) / 2,
				(Display.getCurrent().getBounds().height - shlAbout.getBounds().height) / 2);

		composite = new Composite(shlAbout, SWT.NONE);
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false,
				1, 1));
		composite.setLayout(new GridLayout(4, false));

		lblNewLabel_2 = new Label(composite, SWT.NONE);
		lblNewLabel_2.setText("Homepage:");

		lblNewLabel_3 = new Label(composite, SWT.NONE);
		lblNewLabel_3.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				Program.launch(lblNewLabel_3.getText());
			}
		});
		lblNewLabel_3
				.setForeground(SWTResourceManager.getColor(SWT.COLOR_BLUE));
		lblNewLabel_3.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true,
				false, 1, 1));
		lblNewLabel_3.setText("http://sourceforge.net/projects/phonixj/");
		new Label(composite, SWT.NONE);

		btnNewButton = new Button(composite, SWT.NONE);
		btnNewButton.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false,
				false, 1, 1));
		btnNewButton.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				shlAbout.dispose();
			}
		});
		btnNewButton.setImage(PUtils.getImage(this, "png/arrow-big-01.png"));
		btnNewButton.setToolTipText(PUtils.UTF8("BUTTON_CLOSE"));
		shlAbout.open();
		shlAbout.layout();
		Display display = getParent().getDisplay();
		while (!shlAbout.isDisposed()) {
			if (!display.readAndDispatch()) {
				display.sleep();
			}
		}
		return result;
	}

	/**
	 * Create contents of the dialog.
	 */
	private void createContents() {
		shlAbout = new Shell(getParent(), getStyle());
		shlAbout.setSize(450, 322);
		shlAbout.setText("About");
		shlAbout.setLayout(new GridLayout(2, false));

		lblNewLabel = new Label(shlAbout, SWT.NONE);
		lblNewLabel.setLayoutData(new GridData(SWT.LEFT, SWT.TOP, false, false,
				1, 2));
		lblNewLabel.setImage(PUtils.getImage(this, "png/Csaba.png"));
		lblNewLabel.setToolTipText("Csaba Mészáros");

		lblNewLabel_1 = new Label(shlAbout, SWT.NONE);
		lblNewLabel_1.setText("PhonixJ-1.0.3");

		styledText = new StyledText(shlAbout, SWT.BORDER | SWT.READ_ONLY
				| SWT.WRAP);
		styledText.setTopMargin(5);
		styledText.setRightMargin(5);
		styledText.setLeftMargin(5);
		styledText
				.setText("This program has been developed by Csaba Mészáros. \nIt is written in Java using the SWT graphical framework as frontend\nand SQLite as database backend.\n\nSpecial thanks to the creator of the iconbeast-lite icon set, which is used in this application.(http://www.iconbeast.com/free/)\n\nContact: \nE-mail: mohareve@gmail.com \nor\nSkype: nabimusza\n2013.");
		styledText.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true,
				1, 1));
		new Label(shlAbout, SWT.NONE);

	}

}
