package phonix;

import java.awt.Toolkit;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.StringSelection;
import java.util.ArrayList;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.program.Program;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;

public class Mailer extends Dialog {

	protected Object result;
	protected Shell shell;
	private ArrayList<Button> chboxes = new ArrayList<>();
	private ArrayList<Label> labels = new ArrayList<>();
	private DatabaseConnector connection;
	private Composite composite;
	private ScrolledComposite scrolledComposite;
	private Composite box;
	private Label lblNewLabel_1;
	private Combo combo;
	private Button btnNewButton;
	private Button btnNewButton1;
	private Button btnNewButton_2;
	private Label lblNewLabel_2;
	private Button btnCheckButton_1;
	private String lat = "png/arrow-small-14.png";

	/**
	 * Create the dialog.
	 * 
	 * @param parent
	 * @param style
	 */
	public Mailer(Shell parent, DatabaseConnector db) {
		super(parent, SWT.PRIMARY_MODAL);
		this.connection = db;
	}

	/**
	 * Open the dialog.
	 * 
	 * @return the result
	 */
	public Object open() {
		createContents();
		shell.setLocation(
				(Display.getCurrent().getBounds().width - shell.getBounds().width) / 2,
				(Display.getCurrent().getBounds().height - shell.getBounds().height) / 2);
		shell.setLayout(new GridLayout(1, false));

		composite = new Composite(shell, SWT.NONE);
		composite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false,
				1, 1));
		composite.setLayout(new GridLayout(5, false));

		lblNewLabel_1 = new Label(composite, SWT.NONE);
		lblNewLabel_1.setText(PUtils.UTF8("STRING_CA") + ":");

		combo = new Combo(composite, SWT.READ_ONLY);
		combo.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				fillMails();
			}
		});
		combo.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1,
				1));
		combo.add("*.*");
		for (Two t : connection.getCategories()) {
			combo.add(t.getName());
		}
		if (combo.getItemCount() > 0)
			combo.select(0);
		btnNewButton = new Button(composite, SWT.NONE);
		btnNewButton.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				if (lat.equals("png/arrow-small-14.png")) {
					for (Button b : chboxes) {
						b.setSelection(true);
					}
					lat = "png/arrow-small-13.png";
					btnNewButton.setImage(PUtils.getImage(this, lat));
				} else {
					for (Button b : chboxes) {
						b.setSelection(false);
					}
					lat = "png/arrow-small-14.png";
					btnNewButton.setImage(PUtils.getImage(this, lat));
				}
			}

		});
		btnNewButton.setImage(PUtils.getImage(this, lat));
		btnNewButton.setToolTipText(PUtils.UTF8("TOOLTIP_SELECT_UNSELECT"));

		btnNewButton_2 = new Button(composite, SWT.NONE);
		btnNewButton_2.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				StringBuffer sx = new StringBuffer();
				String mai = "-";
				for (Button b : chboxes) {
					if (b.getSelection()) {
						sx.append(b.getText() + ",");
					}
				}
				mai = sx.toString();
				mai = mai.substring(0, mai.length());
				if (!mai.equals("")) {
					StringSelection stringSelection = new StringSelection(mai);
					Clipboard clpbrd = Toolkit.getDefaultToolkit()
							.getSystemClipboard();
					clpbrd.setContents(stringSelection, null);
					Program.launch("mailto:" + mai);
				}
				shell.dispose();
			}
		});
		btnNewButton_2.setImage(PUtils.getImage(this, "png/email.png"));
		btnNewButton_2.setToolTipText(PUtils.UTF8("BUTTON_COPY"));

		btnNewButton1 = new Button(composite, SWT.NONE);
		btnNewButton1.setLayoutData(new GridData(SWT.LEFT, SWT.FILL, false,
				false, 1, 1));
		btnNewButton1.addMouseListener(new MouseAdapter() {
			@Override
			// Close the dialog
			public void mouseUp(MouseEvent e) {
				shell.dispose();
			}
		});
		btnNewButton1.setImage(PUtils.getImage(this, "png/arrow-big-01.png"));

		scrolledComposite = new ScrolledComposite(shell, SWT.V_SCROLL);
		scrolledComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true,
				true, 1, 1));
		scrolledComposite.setExpandHorizontal(true);
		scrolledComposite.setExpandVertical(true);

		box = new Composite(scrolledComposite, SWT.FILL);
		box.setLayout(new GridLayout(2, true));
		box.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false));

		shell.open();
		shell.layout();
		Display display = getParent().getDisplay();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch()) {
				display.sleep();
			}
		}
		return result;
	}

	/**
	 * Create contents of the dialog.
	 */
	private void createContents() {
		shell = new Shell(getParent(), getStyle());
		shell.setSize(614, 300);

	}

	private void fillMails() {
		ArrayList<Country> iti = connection.getMails(combo.getText());
		for (Label l : labels) {
			l.dispose();
		}
		for (Button b : chboxes) {
			b.dispose();
		}
		chboxes.clear();
		labels.clear();
		for (Country c : iti) {
			lblNewLabel_2 = new Label(box, SWT.NONE);
			lblNewLabel_2.setLayoutData(new GridData(SWT.FILL, SWT.CENTER,
					true, false, 1, 1));
			lblNewLabel_2.setText(c.getName());

			btnCheckButton_1 = new Button(box, SWT.CHECK);
			btnCheckButton_1.setLayoutData(new GridData(SWT.FILL, SWT.CENTER,
					true, false, 1, 1));
			btnCheckButton_1.setText(c.getCode());
			chboxes.add(btnCheckButton_1);
			labels.add(lblNewLabel_2);
		}
		box.layout();
		scrolledComposite.setContent(box);
		scrolledComposite.setMinSize(box.computeSize(SWT.DEFAULT, SWT.DEFAULT));
	}
}
