package phonix;

import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;

public class Notes extends Dialog {

	protected Object result;
	protected Shell shell;
	private Group grpNotes;
	private Button btnNewButton;
	private StyledText styledText;
	private DatabaseConnector connection;
	private int ID;
	private String name;

	/**
	 * Create the dialog.
	 * 
	 * @param parent
	 * @param style
	 */
	public Notes(Shell parent, DatabaseConnector connection, int id, String name) {
		super(parent, SWT.NONE);
		this.connection = connection;
		this.ID = id;
		this.name = name;
		setText(PUtils.UTF8("TITLE_NOTES"));
	}

	/**
	 * Open the dialog.
	 * 
	 * @return the result
	 */
	public Object open() {
		createContents();
		shell.setLocation(
				(Display.getCurrent().getBounds().width - shell.getBounds().width) / 2,
				(Display.getCurrent().getBounds().height - shell.getBounds().height) / 2);
		shell.open();

		shell.layout();
		Display display = getParent().getDisplay();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch()) {
				display.sleep();
			}
		}
		return result;
	}

	/**
	 * Create contents of the dialog.
	 */
	private void createContents() {
		shell = new Shell(getParent(), SWT.DIALOG_TRIM | SWT.PRIMARY_MODAL);
		shell.setSize(380, 350);
		shell.setText(getText());
		shell.setLayout(new GridLayout(1, false));

		grpNotes = new Group(shell, SWT.NONE);
		grpNotes.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1,
				1));
		grpNotes.setText(name + ":");
		grpNotes.setLayout(new GridLayout(1, false));

		styledText = new StyledText(grpNotes, SWT.BORDER | SWT.WRAP);
		styledText.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true,
				1, 1));
		styledText.setText(connection.getNotes(ID));

		btnNewButton = new Button(shell, SWT.NONE);
		btnNewButton.addMouseListener(new MouseAdapter() {
			@Override
			// Save and close
			public void mouseUp(MouseEvent e) {
				connection.saveNotes(styledText.getText(), ID);
				shell.dispose();
			}
		});
		btnNewButton.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false,
				false, 1, 1));
		btnNewButton.setText(PUtils.UTF8("BUTTON_SAVE_AND_CLOSE"));

	}

}
