package phonix;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.UnsupportedEncodingException;
import java.nio.channels.FileChannel;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Locale;
import java.util.ResourceBundle;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.List;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.printing.PrintDialog;
import org.eclipse.swt.printing.Printer;
import org.eclipse.swt.printing.PrinterData;

public class PUtils {
	private static ResourceBundle resources=ResourceBundle.getBundle("phonix.resources/Main");
	private static ArrayList<Country> countryList=new ArrayList<>();
static{
	 String[] countryCodes = Locale.getISOCountries(); 
	final Locale l=Locale.getDefault();
	    for (String countryCode : countryCodes) {
	    	countryList.add(new Country(countryCode, new Locale("", countryCode).getDisplayCountry(l)));
	    }  
	
	Collections.sort(countryList);
}

public static ArrayList<Country> getCountries(){
	return countryList;
}

public static String codeToCountry(String code){
	String c="-";
	for(Country m:countryList){
		if(m.getCode().equals(code)){
			c=m.getName();
			break;
		}
	}
	return c;
}

public static String countryToCode(String country){
	String c="-";
	for(Country m:countryList){
		if(m.getName().equals(country)){
			c=m.getCode();
			break;
		}
	}
	return c;
}
	
	public static void writeConfig(String file, File f) {
		BufferedWriter ps;
		
		try {
			ps = new BufferedWriter(new FileWriter(f));
			ps.write(file);
			ps.flush();
			ps.close();
		} catch (IOException e) {
			e.printStackTrace();
		}

	}
	
	public static String UTF8(String x) {
		String val = resources.getString(x);
		try {
			val = new String(val.getBytes("ISO-8859-1"), "UTF-8");
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
		}
		return val;
	}
	
	public static ArrayList<String> one(ArrayList<Person> persi,OutputFormatter formatter){
		String first = null;
		ArrayList<String> rows = new ArrayList<>();
		first = persi.get(0).getName().substring(0, 1).toUpperCase();
		rows.add("---------------------------------- " + first
				+ " -----------------------------------");
		for (Person p : persi) {
			String second = p.getName().substring(0, 1).toUpperCase();
			if (!second.equals(first)) {
				rows.add("\n");
				rows.add("---------------------------------- " + second
						+ " -----------------------------------");
				first = second;
			}
			int a = p.getName().length() + p.getTele(formatter).length();
			StringBuffer x = new StringBuffer();
			for (int j = 0; j < 72 - a; j++)
				x.append(".");
			rows.add(p.getName() + x.toString() + p.getTele(formatter));
		}
		return rows;
	}
	
	public static ArrayList<String> two(ArrayList<Person> persi,OutputFormatter formatter){
		ArrayList<String> rows = new ArrayList<>();
		String first = null;
		first = persi.get(0).getName().substring(0, 1).toUpperCase();
		rows.add("---------------------------------- " + first
				+ " -----------------------------------");
		for (Person p : persi) {
			String second = p.getName().substring(0, 1).toUpperCase();
			if (!second.equals(first)) {
				rows.add("\n");
				rows.add("---------------------------------- " + second
						+ " -----------------------------------");
				first = second;
			}
			int a = p.getName().length() + p.getAddress().length()
					+ p.getTele(formatter).length();
			StringBuffer x = new StringBuffer();
			for (int j = 0; j < 71 - a; j++)
				x.append(".");
			rows.add(p.getName() + x.toString() + p.getAddress() + ","
					+ p.getTele(formatter));
		}
		return rows;
	}
	
	public static ArrayList<String> three(ArrayList<Person> persi,OutputFormatter formatter){
		ArrayList<String> rows = new ArrayList<>();
		int i = 0;
		for (Person p : persi) {
			StringBuffer sb = new StringBuffer();
			++i;
			sb.append(String.format("%1$-4s. %2$66s \n", i, p.getName()));
			sb.append(String.format("%1$-35s  %2$35s \n",
					PUtils.UTF8("STRING_PHONE"), p.getTele(formatter)));
			sb.append(String.format("%1$-35s  %2$35s \n",
					PUtils.UTF8("LABEL_ADDRESS"), p.getAddress()));
			sb.append(String.format("%1$-35s  %2$35s \n",
					PUtils.UTF8("STRING_ZIP_PLACE"),
					p.getZIP() + " " + p.getPlace()));
			sb.append(String.format("%1$-35s  %2$35s \n",
					PUtils.UTF8("LABEL_EMAIL"), p.getMail()));
			sb.append(String.format("%1$-35s  %2$35s \n",
					PUtils.UTF8("LABEL_WEBSITE"), p.getWebsite()));
			rows.add(sb.toString());

		}
		return rows;
	}
	
	public static ArrayList<String> four(ArrayList<Person> persi,int itemcount,boolean onCB,boolean letterCB,boolean tagsCB,List chosenList,OutputFormatter formatter){
		int j = 0;
		ArrayList<String> rows = new ArrayList<>();
		String first=persi.get(0).getName().substring(0,1).toUpperCase();
		String second=null;
		if(letterCB){
			rows.add("---------------------------------- " + first
					+ " -----------------------------------\n");
		}
		for (Person p : persi) {
			StringBuffer sb = new StringBuffer();
			++j;
			if(letterCB){
				second=persi.get(j-1).getName().substring(0,1).toUpperCase();
				if(!second.equals(first)){
					rows.add("---------------------------------- " + second
							+ " -----------------------------------\n");
					first=second;
				}
			}
			if (onCB)
				sb.append(j + ".\n");
			for (int k = 0; k < itemcount; ++k) {
				if (tagsCB) {
					if (chosenList.getItem(k).equals(
							PUtils.UTF8("STRING_NA"))) {
						sb.append(String.format("%1$-35s  %2$35s \n",
								PUtils.UTF8("LABEL_NAME"), p.getName()));
					}
					if (chosenList.getItem(k).equals(
							PUtils.UTF8("STRING_NU"))) {
						sb.append(String.format("%1$-35s  %2$35s \n",
								PUtils.UTF8("LABEL_NUMBER"), p.getTele(formatter)));
					}
					if (chosenList.getItem(k).equals(
							PUtils.UTF8("STRING_AD"))) {
						sb.append(String.format("%1$-35s  %2$35s \n",
								PUtils.UTF8("LABEL_ADDRESS"),
								p.getAddress()));
					}
					if (chosenList.getItem(k).equals(
							PUtils.UTF8("STRING_PL"))) {
						sb.append(String.format("%1$-35s  %2$35s \n",
								PUtils.UTF8("LABEL_PLACE"), p.getPlace()));
					}
					if (chosenList.getItem(k).equals(
							PUtils.UTF8("STRING_ZC"))) {
						sb.append(String.format("%1$-35s  %2$35s \n",
								PUtils.UTF8("LABEL_ZIP"), p.getZIP()));
					}
					if (chosenList.getItem(k).equals(
							PUtils.UTF8("STRING_EM"))) {
						sb.append(String.format("%1$-35s  %2$35s \n",
								PUtils.UTF8("LABEL_EMAIL"), p.getMail()));
					}
					if (chosenList.getItem(k).equals(
							PUtils.UTF8("STRING_WS"))) {
						sb.append(String.format("%1$-35s  %2$35s \n",
								PUtils.UTF8("LABEL_WEBSITE"),
								p.getWebsite()));
					}
					if (chosenList.getItem(k).equals(
							PUtils.UTF8("STRING_CO"))) {
						sb.append(String.format("%1$-35s  %2$35s \n",
								PUtils.UTF8("LABEL_COUNTRY"),
								codeToCountry(p.getCountry())));
					}
				} else {
					if (chosenList.getItem(k).equals(
							PUtils.UTF8("STRING_NA"))) {
						sb.append(p.getName() + "\n");
					}
					if (chosenList.getItem(k).equals(
							PUtils.UTF8("STRING_NU"))) {
						sb.append(p.getTele(formatter) + "\n");
					}
					if (chosenList.getItem(k).equals(
							PUtils.UTF8("STRING_AD"))) {
						sb.append(p.getAddress() + "\n");
					}
					if (chosenList.getItem(k).equals(
							PUtils.UTF8("STRING_PL"))) {
						sb.append(p.getPlace() + "\n");
					}
					if (chosenList.getItem(k).equals(
							PUtils.UTF8("STRING_ZC"))) {
						sb.append(p.getZIP() + "\n");
					}
					if (chosenList.getItem(k).equals(
							PUtils.UTF8("STRING_EM"))) {
						sb.append(p.getMail() + "\n");
					}
					if (chosenList.getItem(k).equals(
							PUtils.UTF8("STRING_WS"))) {
						sb.append(p.getWebsite() + "\n");
					}
					if (chosenList.getItem(k).equals(
							PUtils.UTF8("STRING_CO"))) {
						sb.append(codeToCountry(p.getCountry()) + "\n");
					}
				}
			}

			rows.add(sb.toString());

		}
		return rows;
	}
	
	public static void copyFile(File sourceFile, File destFile)
			throws IOException {
		if (!destFile.exists()) {
			destFile.createNewFile();
		}

		FileChannel source = null;
		FileChannel destination = null;
		try {
			source = new FileInputStream(sourceFile).getChannel();
			destination = new FileOutputStream(destFile).getChannel();
			destination.transferFrom(source, 0, source.size());
		} finally {
			if (source != null) {
				source.close();
			}
			if (destination != null) {
				destination.close();
			}
		}
	}
	
	public static String formatNumber(String x) {
		StringBuffer sb = new StringBuffer();
			char[] cs = x.toCharArray();
			for (int i = 0; i < cs.length; ++i) {
				if (Character.isDigit(cs[i])) {
					sb.append(cs[i]);
				}			
			}		
		return sb.toString();
	}
	
	
	
	public static StringBuffer vCard(Person p) {
		StringBuffer s = new StringBuffer("BEGIN:VCARD\n");		
		s.append("ADR;TYPE=home:;;" + p.getAddress() + ";" + p.getPlace() + ";;"
				+ p.getZIP() +";"+PUtils.codeToCountry(p.getCountry())+ "\n");
		
		for(String rt:p.getEmail()){
			s.append("EMAIL:" + rt + "\n");
		}
		
		String n = p.getName();
		String[] pn = n.split(" ");
		int q = pn.length;
		String first = pn[q - 1];
		String second = "";
		if (q > 2) {
			for (int i = 0; i < q - 1; ++i){
				second=second.concat(pn[i] + " ");
			}
		} else
			second = pn[0];

		second = second.trim();
		s.append("FN:" + n + "\n");
		s.append("N:" + first + ";" + second + "\n");
		for(String rt:p.getNumber()){
			s.append("TEL:" + rt + "\n");
		}
		s.append("URL:" + p.getWebsite() + "\n");
		s.append("VERSION:3.0\n");		
		s.append("END:VCARD\n\n");
		return s;		
	}
	
	public static Color getColor(Display display,int r,int g,int b){
		Color color = new Color(display, r, g, b);
		return color;
	}
	public static Image getImage(Object o,String s){
		InputStream stream=o.getClass().getClassLoader()
		.getResourceAsStream(s);
		Image icon=new Image(Display.getDefault(), stream);
		try {
			stream.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return icon;
	}
	
	public static void print(Shell shell,String file){
		PrintDialog dialog = new PrintDialog(shell);
	    PrinterData printerData = dialog.open();
	    if (printerData != null) {
	      Printer printer = new Printer(printerData);
	        new WrappingPrinter(printer,file).print();
	    }	   
	}
	
	
	public static Combo CountryCombo(Composite parent){
		
		
		Combo c=new Combo(parent, SWT.READ_ONLY);
		c.add("-");
		for (Country d : countryList) {
			c.add(d.getName());
		}				
		c.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true,
				false, 1, 1));
		return c;
	}
	public static ArrayList<Person> vCardToPerson(String s){
		ArrayList<Person> personas=new ArrayList<>();
		Person person=null;
		File f=new File(s);
		String line=null;
		ArrayList<StringBuffer> tags=new ArrayList<>();
		StringBuffer sb=new StringBuffer();	
		String btext=null;
		String[] lines=null;
		String[] subtags=null;
		String[] address=null;
		String name="-";
		String website="-";
		String adr="-";
		String city="-";
		String zip="-";
		String country="-";
		ArrayList<String> phones=null;
		ArrayList<String> mails=null;
		try {
			BufferedReader br=new BufferedReader(new FileReader(f));
				while((line=br.readLine())!=null){
				if(!line.startsWith("END:VCARD")){
				sb.append(line+"\n");
				}
				if(line.startsWith("END:VCARD")){
					tags.add(sb);
					sb=new StringBuffer();
				}				
			}
			br.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		for(StringBuffer buff:tags){
			mails=new ArrayList<>();
			phones=new ArrayList<>();
			btext=buff.toString();
			lines=btext.split("\n");
			for(int i=0;i<lines.length;++i){
				if(lines[i].startsWith("EMAIL")){
					subtags=lines[i].split(":");
					mails.add(subtags[1]);
				}
				if(lines[i].startsWith("FN")){
					subtags=lines[i].split(":");
					name=subtags[1];
				}
				if(lines[i].startsWith("TEL")){
					subtags=lines[i].split(":");
					phones.add(formatNumber(subtags[1]));
				}
				if(lines[i].startsWith("ADR")){
					subtags=lines[i].split(":");
					address=subtags[1].split(";");
					adr=address[2];
					city=address[3];
					zip=address[5];
					country=PUtils.countryToCode(address[6]);
					
				}
				if(lines[i].startsWith("URL")){
					System.out.println(lines[i]);
					website=lines[i].substring(4);
				}
			}
			person = new Person.Builder().name(name)
					.number(phones).address(adr)
					.place(city).ZIP(zip).country(country)
					.website(website).email(mails)
					.build();
			personas.add(person);
		}
		return personas;
		
		
	}


public static ArrayList<Country> getCountries(final Locale inLocale) {
    String[] countryCodes = Locale.getISOCountries();
    ArrayList<Country> countries = new ArrayList<Country>(countryCodes.length);
    for (String countryCode : countryCodes) {
      countries.add(new Country(countryCode, new Locale("", countryCode).getDisplayCountry(inLocale)));
    }   

    return countries;
}


  }