package phonix;

import java.util.ArrayList;

public class Person implements Humanoid,Comparable<Person>{
private int ID=0;
private String name="-";
private Numbers number;
private String address="-";
private String place="-";
private String ZIP="-";
private Numbers email;
private String website="-";
private int place_id=0;
private String country;
public int getPlace_id() {
	return place_id;
}
	static class Builder{
		private int ID=0;
		private String name="-";
		private Numbers number=new Numbers();
		private String address="-";
		private String place="-";
		private String ZIP="-";
		private Numbers email=new Numbers();
		private String website="-";
		private int place_id=0;
		private String country;
		public Builder place_id(int x){
			this.place_id=x;
			return this;
		}

		public Builder ID(int x){
			this.ID=x;
			return this;
		}
		
		public Builder name(String x){
			this.name=x;
			return this;
		}
		public Builder country(String x){
			this.country=x;
			return this;
		}
		public Builder number(ArrayList<String> x){
			this.number.setNumbers(x);
			return this;
		}
		public Builder address(String x){
			this.address=x;
			return this;
		}
		public Builder place(String x){
			this.place=x;
			return this;
		}
		public Builder ZIP(String x){
			this.ZIP=x;
			return this;
		}
		public Builder email(ArrayList<String> x){
			this.email.setNumbers(x);
			return this;
		}
		public Builder website(String x){
			this.website=x;
			return this;
		}
		public Person build(){
			return new Person(this);
		}
	}
	public Person(Builder builder){ 
		this.ID=builder.ID;
		this.address=builder.address;
		this.email=builder.email;
		this.name=builder.name;
		this.number=builder.number;
		this.ZIP=builder.ZIP;
		this.website=builder.website;
		this.place=builder.place;
		this.place_id=builder.place_id;
		this.country=builder.country;
	}
	public  String getName() {
		return name;
	}
	public String getTele(){
		return this.number.display();
	}
	public String getTele(OutputFormatter formatter){
		return this.number.display(formatter);
	}
	public String getMail(){
		return this.email.display();
	}
	public String getCountry(){
		return this.country;
	}
	public  void setName(String name) {
		this.name = name;
	}
	public  ArrayList<String> getNumber() {
		return number.getNumbers();
	}
	
	public  ArrayList<String> getNumber(OutputFormatter formatter) {
		return number.getNumbers(formatter);
	}
	
	public  void setNumber(ArrayList<String> x) {
		this.number.setNumbers(x);
	}
	public  String getAddress() {
		return address;
	}
	public  void setAddress(String address) {
		this.address = address;
	}
	public  String getPlace() {
		return place;
	}
	public  void setPlace(String place) {
		this.place = place;
	}
	public  String getZIP() {
		return ZIP;
	}
	public synchronized void setZIP(String zIP) {
		ZIP = zIP;
	}
	public  ArrayList<String> getEmail() {
		return email.getNumbers();
	}
	public  void setEmail(ArrayList<String> x) {
		this.email.setNumbers(x);
	}
	public  String getWebsite() {
		return website;
	}
	public  void setWebsite(String website) {
		this.website = website;
	}
	public String toString(){
		return "Name is: "+name+"\n Number is: "+number.display()+"\n Address is: "+address+"\n Place is: "+place+"\n Zip is: "+ZIP+"\n Email is: "+email+"\n Website is: "+website;
		
	}
	
	
	
	public int getID() {
		return ID;
	}
	public void setID(int iD) {
		ID = iD;
	}

	
	
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ID;
		result = prime * result + ((ZIP == null) ? 0 : ZIP.hashCode());
		result = prime * result + ((address == null) ? 0 : address.hashCode());
		result = prime * result + ((country == null) ? 0 : country.hashCode());
		result = prime * result + ((email == null) ? 0 : email.hashCode());
		result = prime * result + ((name == null) ? 0 : name.hashCode());
		result = prime * result + ((number == null) ? 0 : number.hashCode());
		result = prime * result + ((place == null) ? 0 : place.hashCode());
		result = prime * result + place_id;
		result = prime * result + ((website == null) ? 0 : website.hashCode());
		return result;
	}
	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (!(obj instanceof Person)) {
			return false;
		}
		Person other = (Person) obj;
		if (ID != other.ID) {
			return false;
		}
		if (ZIP == null) {
			if (other.ZIP != null) {
				return false;
			}
		} else if (!ZIP.equals(other.ZIP)) {
			return false;
		}
		if (address == null) {
			if (other.address != null) {
				return false;
			}
		} else if (!address.equals(other.address)) {
			return false;
		}
		if (country == null) {
			if (other.country != null) {
				return false;
			}
		} else if (!country.equals(other.country)) {
			return false;
		}
		if (email == null) {
			if (other.email != null) {
				return false;
			}
		} else if (!email.equals(other.email)) {
			return false;
		}
		if (name == null) {
			if (other.name != null) {
				return false;
			}
		} else if (!name.equals(other.name)) {
			return false;
		}
		if (number == null) {
			if (other.number != null) {
				return false;
			}
		} else if (!number.equals(other.number)) {
			return false;
		}
		if (place == null) {
			if (other.place != null) {
				return false;
			}
		} else if (!place.equals(other.place)) {
			return false;
		}
		if (place_id != other.place_id) {
			return false;
		}
		if (website == null) {
			if (other.website != null) {
				return false;
			}
		} else if (!website.equals(other.website)) {
			return false;
		}
		return true;
	}
	@Override
	public int compareTo(Person o) {
		return name.compareTo(o.getName());
	}
	
	
}
