package phonix;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.ArrayList;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.wb.swt.SWTResourceManager;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.List;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.MessageBox;

public class Printing extends Shell {
	private Group grpDetails;
	private Button btnRadioButton;
	private Button btnRadioButton_1;
	private Button btnRadioButton_2;
	private Button btnNewButton;
	private static DatabaseConnector connection;
	private static int mode = 0;
	private static Printing shell;

	private Button otherRB;
	private Group specialGroup;
	private Label lblNewLabel;
	private Label lblNewLabel_1;
	private List compoList;
	private List chosenList;
	private Composite composite;
	private static String[] components;
	private Menu menu;
	private MenuItem menuUp;
	private MenuItem menuDown;
	private Button onCB;
	private Button tagsCB;
	private static ArrayList<Person> incoming = new ArrayList<>();
	private Button btnCheckButton;

	/**
	 * Launch the application.
	 * 
	 * @param args
	 */
	public static void main(DatabaseConnector con, ArrayList<Person> p) {
		connection = con;
		incoming = p;
		components = new String[] { PUtils.UTF8("STRING_NA"),
				PUtils.UTF8("STRING_NU"), PUtils.UTF8("STRING_AD"),
				PUtils.UTF8("STRING_PL"), PUtils.UTF8("STRING_ZC"),
				PUtils.UTF8("STRING_EM"), PUtils.UTF8("STRING_WS"),
				PUtils.UTF8("STRING_CO") };
		try {
			Display display = Display.getDefault();
			shell = new Printing(display);
			shell.setLocation((Display.getCurrent().getBounds().width - shell
					.getBounds().width) / 2,
					(Display.getCurrent().getBounds().height - shell
							.getBounds().height) / 2);
			shell.open();
			shell.layout();
			while (!shell.isDisposed()) {
				if (!display.readAndDispatch()) {
					display.sleep();
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the shell.
	 * 
	 * @param display
	 */
	public Printing(Display display) {
		super(display, SWT.SHELL_TRIM);
		setLayout(new GridLayout(1, false));

		grpDetails = new Group(this, SWT.NONE);
		grpDetails.setFont(SWTResourceManager.getFont("Sans", 9, SWT.BOLD));
		grpDetails.setText(PUtils.UTF8("GROUP_DETAILS"));
		grpDetails.setLayout(new GridLayout(1, false));
		grpDetails.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true,
				1, 1));

		btnRadioButton = new Button(grpDetails, SWT.RADIO);
		btnRadioButton.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				mode = 0;
				if (specialGroup != null) {
					specialGroup.dispose();
					specialGroup = null;
					grpDetails.layout();
					shell.pack();
				}
			}
		});
		btnRadioButton.setSelection(true);
		btnRadioButton.setLayoutData(new GridData(SWT.LEFT, SWT.FILL, true,
				true, 1, 1));
		btnRadioButton.setText(PUtils.UTF8("RADIO_NAME_PHONE"));

		btnRadioButton_1 = new Button(grpDetails, SWT.RADIO);
		btnRadioButton_1.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				mode = 1;
				if (specialGroup != null) {
					specialGroup.dispose();
					specialGroup = null;
					grpDetails.layout();
					shell.pack();
				}
			}
		});
		btnRadioButton_1.setLayoutData(new GridData(SWT.LEFT, SWT.FILL, true,
				true, 1, 1));
		btnRadioButton_1.setText(PUtils.UTF8("RADIO_NAME_ADDRESS"));

		btnRadioButton_2 = new Button(grpDetails, SWT.RADIO);
		btnRadioButton_2.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				mode = 2;
				if (specialGroup != null) {
					specialGroup.dispose();
					specialGroup = null;
					grpDetails.layout();
					shell.pack();
				}
			}
		});
		btnRadioButton_2.setLayoutData(new GridData(SWT.LEFT, SWT.FILL, true,
				true, 1, 1));
		btnRadioButton_2.setText(PUtils.UTF8("RADIO_ALL"));

		otherRB = new Button(grpDetails, SWT.RADIO);
		otherRB.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, true, true, 1,
				1));
		otherRB.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				mode = 3;
				addOption();

			}
		});
		otherRB.setText(PUtils.UTF8("RADIO_OTHER"));
		// TEMP

		//
		btnNewButton = new Button(this, SWT.NONE);
		btnNewButton.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				ArrayList<String> elements = null;
				if (incoming == null) {
					elements = prepareBook(null);
				} else {
					elements = prepareBook(incoming);
				}
				FileDialog dialog = new FileDialog(shell, SWT.SAVE);
				dialog.setFilterNames(new String[] { "Text files" });
				dialog.setFilterExtensions(new String[] { "*.txt" });
				dialog.setFilterPath(System.getProperty("user.home"));
				dialog.setFileName("PhoneBook.txt");
				String fname = dialog.open();
				if (fname != null) {
					File f = new File(fname);
					try {
						PrintStream ps = new PrintStream(
								new FileOutputStream(f));
						for (String s : elements) {
							ps.println(s);
						}
						ps.close();
					} catch (FileNotFoundException e1) {
						e1.printStackTrace();
					}
					MessageBox messageBox = new MessageBox(shell,
							SWT.ICON_WARNING | SWT.YES | SWT.NO);
					messageBox.setText(PUtils.UTF8("BUTTON_PRINT"));
					messageBox.setMessage(PUtils.UTF8("QUESTION_PRINT"));
					int buttonID = messageBox.open();
					switch (buttonID) {
					case SWT.YES:
						PUtils.print(shell, fname);
					case SWT.NO:
						// exits here ...
						break;
					case SWT.CANCEL:
						// does nothing ...
					}

				}
				shell.dispose();
			}
		});
		btnNewButton.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true,
				false, 1, 1));
		btnNewButton.setImage(PUtils.getImage(this, "png/printer.png"));
		btnNewButton.setText(PUtils.UTF8("BUTTON_PRINT"));

		createContents();
	}

	/**
	 * Create contents of the shell.
	 */
	protected void createContents() {
		setText(PUtils.UTF8("TITLE_PRINT"));
		setSize(390, 341);
		layout();
		pack();
	}

	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}

	private void addOption() {
		if (specialGroup == null) {
			specialGroup = new Group(grpDetails, SWT.NONE);
			specialGroup.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true,
					true, 1, 1));
			specialGroup.setLayout(new GridLayout(5, false));

			onCB = new Button(specialGroup, SWT.CHECK);
			onCB.setSelection(true);
			onCB.setText(PUtils.UTF8("CHECK_ORDER"));

			btnCheckButton = new Button(specialGroup, SWT.CHECK);
			btnCheckButton.setSelection(true);
			btnCheckButton.setText(PUtils.UTF8("CHECK_LETTERS"));
			new Label(specialGroup, SWT.NONE);
			new Label(specialGroup, SWT.NONE);

			tagsCB = new Button(specialGroup, SWT.CHECK);
			tagsCB.setSelection(true);
			tagsCB.setText(PUtils.UTF8("CHECK_TAGS"));

			lblNewLabel = new Label(specialGroup, SWT.NONE);
			lblNewLabel.setText(PUtils.UTF8("STRING_COMPONENTS"));
			new Label(specialGroup, SWT.NONE);
			new Label(specialGroup, SWT.NONE);
			new Label(specialGroup, SWT.NONE);

			lblNewLabel_1 = new Label(specialGroup, SWT.NONE);
			lblNewLabel_1.setText(PUtils.UTF8("STRING_USED"));

			compoList = new List(specialGroup, SWT.BORDER);
			compoList.setToolTipText(PUtils.UTF8("LIST_SELECT_DOUBLECLICK"));
			compoList.addMouseListener(new MouseAdapter() {
				@Override
				public void mouseDoubleClick(MouseEvent e) {
					int index = compoList.getSelectionIndex();
					if (index > -1) {
						String m = compoList.getItem(index);
						compoList.remove(index);
						chosenList.add(m);
					}
				}
			});
			compoList.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true,
					true, 1, 1));
			for (String b : components) {
				compoList.add(b);
			}

			composite = new Composite(specialGroup, SWT.NONE);
			composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false,
					false, 1, 1));
			composite.setLayout(new GridLayout(1, false));
			new Label(specialGroup, SWT.NONE);

			new Label(specialGroup, SWT.NONE);

			chosenList = new List(specialGroup, SWT.BORDER);
			chosenList.addMouseListener(new MouseAdapter() {
				@Override
				public void mouseDoubleClick(MouseEvent e) {
					int index = chosenList.getSelectionIndex();
					if (index > -1) {
						String m = chosenList.getItem(index);
						chosenList.remove(index);
						compoList.add(m);
					}
				}
			});
			chosenList.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true,
					true, 1, 1));
			chosenList.setToolTipText(PUtils.UTF8("LIST_SELECT_DOUBLECLICK"));

			menu = new Menu(chosenList);
			chosenList.setMenu(menu);

			menuUp = new MenuItem(menu, SWT.NONE);
			menuUp.addSelectionListener(new SelectionAdapter() {
				@Override
				public void widgetSelected(SelectionEvent e) {
					int index = chosenList.getSelectionIndex();
					if (index > 0) {
						String a = chosenList.getItem(index);
						String b = chosenList.getItem(index - 1);
						chosenList.setItem(index, b);
						chosenList.setItem(index - 1, a);
						chosenList.select(index - 1);
					}
				}
			});
			menuUp.setText(PUtils.UTF8("MENU_UP"));

			menuDown = new MenuItem(menu, SWT.NONE);
			menuDown.addSelectionListener(new SelectionAdapter() {
				@Override
				public void widgetSelected(SelectionEvent e) {
					int index = chosenList.getSelectionIndex();
					if (index > -1 && index < chosenList.getItemCount() - 1) {
						String a = chosenList.getItem(index);
						String b = chosenList.getItem(index + 1);
						chosenList.setItem(index, b);
						chosenList.setItem(index + 1, a);
						chosenList.select(index + 1);
					}
				}
			});
			menuDown.setText(PUtils.UTF8("MENU_DOWN"));
			grpDetails.layout();
			shell.pack();
		}

	}

	private ArrayList<String> prepareBook(ArrayList<Person> p) {
		ArrayList<String> rows = new ArrayList<>();
		ArrayList<Person> persi = null;
		if (p == null) {
			persi = connection.getAll();
		} else {
			persi = p;
		}
		switch (mode) {
		case 0:// name and number
			rows = PUtils.one(persi, new TripletFormatter());
			break;
		case 1:// name, address and number
			rows = PUtils.two(persi, new TripletFormatter());
			break;
		case 2:// all
			rows = PUtils.three(persi, new TripletFormatter());
			break;
		case 3:
			rows = PUtils.four(persi, chosenList.getItemCount(),
					onCB.getSelection(), btnCheckButton.getSelection(),
					tagsCB.getSelection(), chosenList, new TripletFormatter());
			break;
		}
		return rows;
	}
}
