package phonix;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintStream;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.ArrayList;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.widgets.Composite;

public class Repair extends Shell {
	private static DatabaseConnector connection;
	private static Repair shell;
	private Button changebaseB;
	private Composite composite;
	private Button btnNewButton_1;
	private Button btnNewButton_3;
	private Group grpDatabaseDetails;
	private Label dbPlace;
	private Button btnNewButton_4;
	private static final String DBASE = System.getProperty("user.home")
			+ File.separatorChar + "PhonixJ" + File.separatorChar
			+ "phonixj.db";
	private static final String CONFIG = System.getProperty("user.home")
			+ File.separatorChar + "PhonixJ" + File.separatorChar + "config";
	private Button btnNewButton_6;
	private Info ing;
	private Group grpKategrikKezelse;
	private Composite composite_2;
	private Composite composite_3;
	private Combo combo_1;
	private Button btnNewButton_2;
	private Text text_2;
	private Button btnNewButton_5;
	private Button btnNewButton;
	private Button btnNewButton_7;

	/**
	 * Launch the application.
	 * 
	 * @param args
	 */
	public static boolean main(DatabaseConnector con) {
		connection = con;
		try {
			Display display = Display.getDefault();
			shell = new Repair(display);
			shell.setLocation((Display.getCurrent().getBounds().width - shell
					.getBounds().width) / 2,
					(Display.getCurrent().getBounds().height - shell
							.getBounds().height) / 2);
			shell.open();
			shell.layout();
			while (!shell.isDisposed()) {
				if (!display.readAndDispatch()) {
					display.sleep();
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return true;
	}

	/**
	 * Create the shell.
	 * 
	 * @param display
	 */
	public Repair(Display display) {
		super(display, SWT.SHELL_TRIM);
		setLayout(new GridLayout(2, false));

		grpKategrikKezelse = new Group(this, SWT.NONE);
		grpKategrikKezelse.setLayout(new GridLayout(2, false));
		grpKategrikKezelse.setLayoutData(new GridData(SWT.FILL, SWT.CENTER,
				true, false, 2, 1));
		grpKategrikKezelse.setText(PUtils.UTF8("GROUP_CATEGORIES"));

		composite_2 = new Composite(grpKategrikKezelse, SWT.NONE);
		composite_2.setLayout(new GridLayout(1, false));
		composite_2.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true,
				1, 1));

		combo_1 = new Combo(composite_2, SWT.READ_ONLY);
		combo_1.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false,
				1, 1));
		for (Two t : connection.getCategories()) {
			combo_1.add(t.getName());
		}
		if (combo_1.getItemCount() > 0)
			combo_1.select(0);
		btnNewButton_2 = new Button(composite_2, SWT.NONE);
		btnNewButton_2.addMouseListener(new MouseAdapter() {
			@Override
			// Delete the selected category from the combobox
			public void mouseUp(MouseEvent e) {
				if (combo_1.getItemCount() > 0
						&& combo_1.getSelectionIndex() > -1) {
					connection.deleteCategory(combo_1.getText());
					combo_1.remove(combo_1.getSelectionIndex());
				}
			}
		});
		btnNewButton_2.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false,
				false, 1, 1));
		btnNewButton_2.setImage(PUtils.getImage(this, "png/minus-sign.png"));

		composite_3 = new Composite(grpKategrikKezelse, SWT.NONE);
		composite_3.setLayout(new GridLayout(1, false));
		composite_3.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true,
				1, 1));

		text_2 = new Text(composite_3, SWT.BORDER);
		text_2.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1,
				1));

		btnNewButton_5 = new Button(composite_3, SWT.NONE);
		btnNewButton_5.addMouseListener(new MouseAdapter() {
			@Override
			// Add a new category
			public void mouseUp(MouseEvent e) {
				String h = text_2.getText();
				if (!h.equals("") && combo_1.indexOf(h) == -1) {
					connection.createCategory(h);
					combo_1.removeAll();
					for (Two t : connection.getCategories()) {
						combo_1.add(t.getName());
					}
					text_2.setText("");
					combo_1.select(0);
				}
			}
		});
		btnNewButton_5.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false,
				false, 1, 1));
		btnNewButton_5.setImage(PUtils.getImage(this, "png/plus-sign.png"));

		grpDatabaseDetails = new Group(this, SWT.NONE);
		grpDatabaseDetails.setText(PUtils.UTF8("GROUP_DB_DETAILS"));
		GridData gd_grpDatabaseDetails = new GridData(SWT.FILL, SWT.FILL, true,
				true, 2, 1);
		gd_grpDatabaseDetails.heightHint = 198;
		grpDatabaseDetails.setLayoutData(gd_grpDatabaseDetails);
		grpDatabaseDetails.setLayout(new GridLayout(1, false));

		composite = new Composite(grpDatabaseDetails, SWT.NONE);
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1,
				1));
		composite.setLayout(new GridLayout(7, false));

		btnNewButton = new Button(composite, SWT.NONE);
		btnNewButton.addMouseListener(new MouseAdapter() {
			@Override
			// Import contacts from vCards
			public void mouseUp(MouseEvent e) {
				String file = openDialog("*.vcf");
				if (file != null) {// Check
					ArrayList<Person> ps = PUtils.vCardToPerson(file);
					for (Person p : ps) {
						connection.insertPerson(p);
					}
					shell.dispose();
				}
			}
		});
		btnNewButton.setImage(PUtils.getImage(this, "png/old-phone.png"));
		btnNewButton.setToolTipText(PUtils.UTF8("TOOLTIP_IMPORT_VCARD"));
		btnNewButton.setLayoutData(new GridData(SWT.LEFT, SWT.FILL, false,
				false, 1, 1));

		btnNewButton_7 = new Button(composite, SWT.NONE);
		btnNewButton_7.addMouseListener(new MouseAdapter() {
			@Override
			// Export the database into .vcf
			public void mouseUp(MouseEvent e) {
				String file = saveDialog("*.vcf");
				if (file != null) {
					StringBuffer sb = dBaseToVCard();
					try {
						PrintStream ps = new PrintStream(new FileOutputStream(
								new File(file)));
						ps.print(sb);
						ps.close();
					} catch (FileNotFoundException e1) {
						e1.printStackTrace();
					}
					shell.dispose();
				}
			}
		});
		btnNewButton_7.setLayoutData(new GridData(SWT.LEFT, SWT.FILL, false,
				false, 1, 1));
		btnNewButton_7.setImage(PUtils.getImage(this, "png/id-card.png"));
		btnNewButton_7.setToolTipText(PUtils.UTF8("TOOLTIP_EXPORT_VCARD"));

		changebaseB = new Button(composite, SWT.NONE);
		changebaseB.setLayoutData(new GridData(SWT.LEFT, SWT.FILL, false,
				false, 1, 1));
		changebaseB.addMouseListener(new MouseAdapter() {// Replace the existing
															// database with
															// another one
					@Override
					public void mouseUp(MouseEvent e) {
						File f = new File(CONFIG);
						String file = openDialog("*.db");
						if (file != null && connection.isValid(file)) {// Check
							PUtils.writeConfig(file, f);
							connection.changeDB(file);
							shell.dispose();
						}
					}

				});
		changebaseB.setImage(PUtils.getImage(this, "png/color-swap.png"));
		changebaseB.setToolTipText(PUtils.UTF8("BUTTON_DB_REPLACE"));

		btnNewButton_1 = new Button(composite, SWT.NONE);
		btnNewButton_1.addMouseListener(new MouseAdapter() {
			@Override
			// Create a new database
			public void mouseUp(MouseEvent e) {
				String place = openDialog("*.db");
				if (place != null) {
					if (!place.substring(place.length() - 3).equalsIgnoreCase(
							".DB")) {
						place += ".db";
					}
					if (isCreatable(place)) {
						File config = new File(CONFIG);

						if (place != null) {
							connection.changeDB(place);
							PUtils.writeConfig(place, config);
						}
						shell.dispose();
					}
				}
			}
		});
		GridData gd_btnNewButton_1 = new GridData(SWT.LEFT, SWT.FILL, false,
				true, 1, 1);
		gd_btnNewButton_1.heightHint = 26;
		btnNewButton_1.setLayoutData(gd_btnNewButton_1);
		btnNewButton_1.setImage(PUtils.getImage(this, "png/photo.png"));
		btnNewButton_1.setToolTipText(PUtils.UTF8("BUTTON_NEW_DB"));

		btnNewButton_4 = new Button(composite, SWT.NONE);
		btnNewButton_4.addMouseListener(new MouseAdapter() {
			@Override
			// Reset to the default database
			public void mouseUp(MouseEvent e) {
				File config = new File(CONFIG);
				config.delete();
				connection.changeDB(DBASE);
				shell.dispose();
			}
		});
		btnNewButton_4.setLayoutData(new GridData(SWT.LEFT, SWT.FILL, true,
				false, 1, 1));
		btnNewButton_4.setImage(PUtils.getImage(this, "png/home.png"));
		btnNewButton_4.setToolTipText(PUtils.UTF8("BUTTON_DB_DEFAULT"));

		btnNewButton_6 = new Button(composite, SWT.NONE);
		btnNewButton_6.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				ing = new Info(shell, 0);
				ing.open();
			}
		});
		btnNewButton_6.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false,
				true, 1, 1));
		btnNewButton_6.setImage(PUtils.getImage(this, "png/info.png"));

		btnNewButton_3 = new Button(composite, SWT.NONE);
		btnNewButton_3.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				shell.dispose();
			}
		});
		GridData gd_btnNewButton_3 = new GridData(SWT.RIGHT, SWT.FILL, false,
				true, 1, 1);
		gd_btnNewButton_3.heightHint = 26;
		btnNewButton_3.setLayoutData(gd_btnNewButton_3);
		btnNewButton_3.setImage(PUtils.getImage(this, "png/arrow-big-01.png"));
		btnNewButton_3.setToolTipText(PUtils.UTF8("BUTTON_CLOSE"));

		dbPlace = new Label(grpDatabaseDetails, SWT.NONE);
		dbPlace.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, true, 1,
				1));
		getDataBaseLocation();
		createContents();
	}

	private boolean isCreatable(String place) {
		boolean x = true;
		try {
			FileWriter fw = new FileWriter(new File(place));
			fw.close();
			Files.deleteIfExists(Paths.get(place));
		} catch (IOException e) {
			x = false;
		}
		return x;
	}

	/**
	 * Create contents of the shell.
	 */
	protected void createContents() {
		setText(PUtils.UTF8("TITLE_REPAIR"));
		setSize(450, 259);

	}

	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}

	private String openDialog(String type) {
		FileDialog dlg = new FileDialog(shell, SWT.OPEN);
		dlg.setFilterPath(System.getProperty("user.home"));
		dlg.setFilterExtensions(new String[] { type });
		String fileName = dlg.open();
		return fileName;
	}

	private String saveDialog(String type) {
		FileDialog dlg = new FileDialog(shell, SWT.SAVE);
		dlg.setFilterPath(System.getProperty("user.home"));
		dlg.setFileName("Database.vcf");
		dlg.setFilterExtensions(new String[] { type });
		String fileName = dlg.open();
		return fileName;
	}

	private void getDataBaseLocation() {
		BufferedReader br = null;
		File f = new File(CONFIG);
		if (!f.exists()) {
			dbPlace.setText(DBASE);
		} else {
			try {
				br = new BufferedReader(new FileReader(f));
				String s = null;
				while ((s = br.readLine()) != null) {
					dbPlace.setText(s);
				}

			} catch (FileNotFoundException e) {
				e.printStackTrace();
			} catch (IOException e) {
				e.printStackTrace();
			} finally {
				if (br != null) {
					try {
						br.close();
					} catch (IOException e) {
						e.printStackTrace();
					}
				}
			}
		}
	}

	public StringBuffer dBaseToVCard() {
		ArrayList<Person> personas = connection.getAll();
		StringBuffer sb = new StringBuffer();
		for (Person p : personas) {
			sb.append(PUtils.vCard(p));
		}
		return sb;
	}
}
